/** @flow */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _HardwareManager = require('./HardwareManager');

var _HardwareManager2 = _interopRequireDefault(_HardwareManager);

var _findNodeHandle = require('./findNodeHandle');

var _findNodeHandle2 = _interopRequireDefault(_findNodeHandle);

var _reactLibInvariant = require('react/lib/invariant');

var _reactLibInvariant2 = _interopRequireDefault(_reactLibInvariant);

var HardwareMethodsMixin = {
  measure: function measure(callback) {
    console.log('HardwareMethodsMixin#measure', this);
    _HardwareManager2['default'].measure((0, _findNodeHandle2['default'])(this), mountSafeCallback(this, callback));
  } };

/**
 * In the future, we should cleanup callbacks by cancelling them instead of
 * using this.
 */
var mountSafeCallback = function mountSafeCallback(context, callback) {
  return function () {
    if (!callback || context.isMounted && !context.isMounted()) {
      return;
    }
    return callback.apply(context, arguments);
  };
};

exports['default'] = HardwareMethodsMixin;
module.exports = exports['default'];