/** @flow */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _InteractionManager = require('./InteractionManager');

var _InteractionManager2 = _interopRequireDefault(_InteractionManager);

// Interaction handle is created/cleared when responder is granted or
// released/terminated.
var interactionHandle = null;

var ReactHardwareGlobalInteractionHandler = {
  onChange: function onChange(numberActiveReads) {
    if (numberActiveReads === 0) {
      if (interactionHandle) {
        _InteractionManager2['default'].clearInteractionHandle(interactionHandle);
        interactionHandle = null;
      }
    } else if (!interactionHandle) {
      interactionHandle = _InteractionManager2['default'].createInteractionHandle();
    }
  }
};

exports['default'] = ReactHardwareGlobalInteractionHandler;
module.exports = exports['default'];