'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _ReactHardware = require('../ReactHardware');

var _ReactHardware2 = _interopRequireDefault(_ReactHardware);

var _createReactHardwareComponentClass = require('../createReactHardwareComponentClass');

var _createReactHardwareComponentClass2 = _interopRequireDefault(_createReactHardwareComponentClass);

var _inputModes = require('./inputModes');

var _inputModes2 = _interopRequireDefault(_inputModes);

var _HardwareManager = require('../HardwareManager');

var _HardwareManager2 = _interopRequireDefault(_HardwareManager);

var _ReactHardwareEventEmitter = require('../ReactHardwareEventEmitter');

var _ReactHardwareEventEmitter2 = _interopRequireDefault(_ReactHardwareEventEmitter);

var _findNodeHandle = require('../findNodeHandle');

var _findNodeHandle2 = _interopRequireDefault(_findNodeHandle);

var _ComponentUtils = require('./ComponentUtils');

var _defaultPropTypes = require('./defaultPropTypes');

var _defaultPropTypes2 = _interopRequireDefault(_defaultPropTypes);

var PropTypes = _ReactHardware2['default'].PropTypes;

var DOWN_EVENT = 'topDown';
var UP_EVENT = 'topUp';
var CHANGE_EVENT = 'topChange';
var HOLD_EVENT = 'topHold';

var EVENT_TYPE = (0, _ComponentUtils.collect)(_HardwareManager2['default'].customDirectEventTypes, CHANGE_EVENT, DOWN_EVENT, HOLD_EVENT, UP_EVENT);

var BUTTON_REF = 'button';

var viewConfig = {
  uiViewClassName: 'Button',
  validAttributes: {
    pin: true,
    mode: true,

    onHold: true,
    onChange: true,
    onDown: true,
    onUp: true } };

var Button = (function (_React$Component) {
  function Button(props, context) {
    _classCallCheck(this, Button);

    _get(Object.getPrototypeOf(Button.prototype), 'constructor', this).call(this, props, context);

    this.state = {
      isDown: false,
      inverted: props.inverted || false };
  }

  _inherits(Button, _React$Component);

  _createClass(Button, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      // random private data that shouldn’t trigger a render
      this._timer = null;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this = this;

      // set up the hardware polling
      var nodeHandle = (0, _findNodeHandle2['default'])(this.refs[BUTTON_REF]);
      _HardwareManager2['default'].read(nodeHandle, function (newValue) {
        if (newValue !== _this.value) {
          _this.value = newValue;

          // TODO: add support for inverted buttons like johnny-five.
          var eventName = newValue === 0 ? UP_EVENT : DOWN_EVENT;
          (0, _ComponentUtils.emitEvent)(_this, nodeHandle, eventName, newValue);
          (0, _ComponentUtils.emitEvent)(_this, nodeHandle, CHANGE_EVENT, newValue);

          if (eventName === DOWN_EVENT) {
            _this._timer = setTimeout(function (_) {
              return (0, _ComponentUtils.emitEvent)(_this, nodeHandle, HOLD_EVENT, newValue);
            }, _this.props.holdtime);
          } else {
            _this._timer = clearTimeout(_this._timer);
          }
        }
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // TODO: maybe move this destroyer to the HardwareManager
      _HardwareManager2['default'].destroyRead((0, _findNodeHandle2['default'])(this.refs[BUTTON_REF]));
    }
  }, {
    key: 'render',
    value: function render() {
      var props = _extends({}, this.props);

      return _ReactHardware2['default'].createElement(Hardware, _extends({
        ref: BUTTON_REF,
        mode: _inputModes2['default'].INPUT
      }, props));
    }
  }]);

  return Button;
})(_ReactHardware2['default'].Component);

var Hardware = (0, _createReactHardwareComponentClass2['default'])(viewConfig);

Button.propTypes = _extends({}, _defaultPropTypes2['default'], {

  holdtime: PropTypes.number,
  onChange: PropTypes.func,
  onDown: PropTypes.func,
  onHold: PropTypes.func,
  onUp: PropTypes.func });

Button.defaultProps = {
  holdtime: 1000 };

exports['default'] = Button;
module.exports = exports['default'];