'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.emitEvent = emitEvent;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _HardwareManager = require('../HardwareManager');

var _ReactHardwareEventEmitter = require('../ReactHardwareEventEmitter');

var _ReactHardwareEventEmitter2 = _interopRequireDefault(_ReactHardwareEventEmitter);

var _findNodeHandle = require('../findNodeHandle');

var _findNodeHandle2 = _interopRequireDefault(_findNodeHandle);

/**
 * used to create EVENT_TYPE hash for each component
 * to look up variables based on a constant.
 *
 * var EVENT_TYPE = collect(
 *   HardwareManager.customDirectEventTypes,
 *   CHANGE_EVENT, CLOSE_EVENT, OPEN_EVENT
 * );
 *
 * => { topChange: {registrationName: 'onChange'},
 *      topClose: {registrationName: 'onClose'},
 *      topOpen: {registrationName: 'onOpen'},
 *    }
 */
var collect = function collect(obj) {
  for (var _len = arguments.length, things = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    things[_key - 1] = arguments[_key];
  }

  return things.reduce(function (memo, thing) {
    return (memo[thing] = obj[thing], memo);
  }, {});
};

exports.collect = collect;

function emitEvent(componentInstance, nodeHandle, eventName, value) {
  _ReactHardwareEventEmitter2['default'].receiveEvent(nodeHandle, eventName, {
    value: value,
    target: componentInstance,
    type: _HardwareManager.customDirectEventTypes[eventName].registrationName });
}