'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _ReactHardware = require('../ReactHardware');

var _ReactHardware2 = _interopRequireDefault(_ReactHardware);

var _createReactHardwareComponentClass = require('../createReactHardwareComponentClass');

var _createReactHardwareComponentClass2 = _interopRequireDefault(_createReactHardwareComponentClass);

var _inputModes = require('./inputModes');

var _inputModes2 = _interopRequireDefault(_inputModes);

var _HardwareManager = require('../HardwareManager');

var _HardwareManager2 = _interopRequireDefault(_HardwareManager);

var _ReactHardwareEventEmitter = require('../ReactHardwareEventEmitter');

var _ReactHardwareEventEmitter2 = _interopRequireDefault(_ReactHardwareEventEmitter);

var _findNodeHandle = require('../findNodeHandle');

var _findNodeHandle2 = _interopRequireDefault(_findNodeHandle);

var _ComponentUtils = require('./ComponentUtils');

var _defaultPropTypes = require('./defaultPropTypes');

var _defaultPropTypes2 = _interopRequireDefault(_defaultPropTypes);

var PropTypes = _ReactHardware2['default'].PropTypes;

var CHANGE_EVENT = 'topChange';

var EVENT_TYPE = (0, _ComponentUtils.collect)(_HardwareManager2['default'].customDirectEventTypes, CHANGE_EVENT);

var POT_REF = 'potentiometer';

var viewConfig = {
  uiViewClassName: 'Potentiometer',
  validAttributes: {
    pin: true,
    mode: true,

    onChange: true } };

var Potentiometer = (function (_React$Component) {
  function Potentiometer() {
    _classCallCheck(this, Potentiometer);

    if (_React$Component != null) {
      _React$Component.apply(this, arguments);
    }
  }

  _inherits(Potentiometer, _React$Component);

  _createClass(Potentiometer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this = this;

      this.value = 0;
      var nodeHandle = (0, _findNodeHandle2['default'])(this.refs[POT_REF]);
      var read = false;
      // set up the hardware polling
      _HardwareManager2['default'].read(nodeHandle, function (newValue) {
        if (newValue !== _this.value && Math.abs(newValue - _this.value) > _this.props.threshold) {
          _this.value = newValue;

          (0, _ComponentUtils.emitEvent)(_this, nodeHandle, CHANGE_EVENT, newValue);
        }
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // TODO: maybe move this destroyer to the HardwareManager
      _HardwareManager2['default'].destroyRead((0, _findNodeHandle2['default'])(this.refs[POT_REF]));
    }
  }, {
    key: 'render',
    value: function render() {
      var props = _extends({}, this.props);

      return _ReactHardware2['default'].createElement(Hardware, _extends({
        ref: POT_REF,
        mode: _inputModes2['default'].ANALOG
      }, props));
    }
  }]);

  return Potentiometer;
})(_ReactHardware2['default'].Component);

var Hardware = (0, _createReactHardwareComponentClass2['default'])(viewConfig);

Potentiometer.defaultProps = {
  threshold: 10 };

Potentiometer.propTypes = _extends({}, _defaultPropTypes2['default'], {

  threshold: PropTypes.number,
  onChange: PropTypes.func });

exports['default'] = Potentiometer;
module.exports = exports['default'];