'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _ReactHardware = require('../ReactHardware');

var _ReactHardware2 = _interopRequireDefault(_ReactHardware);

var _createReactHardwareComponentClass = require('../createReactHardwareComponentClass');

var _createReactHardwareComponentClass2 = _interopRequireDefault(_createReactHardwareComponentClass);

var _inputModes = require('./inputModes');

var _inputModes2 = _interopRequireDefault(_inputModes);

var _HardwareManager = require('../HardwareManager');

var _HardwareManager2 = _interopRequireDefault(_HardwareManager);

var _findNodeHandle = require('../findNodeHandle');

var _findNodeHandle2 = _interopRequireDefault(_findNodeHandle);

var _ComponentUtils = require('./ComponentUtils');

var _defaultPropTypes = require('./defaultPropTypes');

var _defaultPropTypes2 = _interopRequireDefault(_defaultPropTypes);

var PropTypes = _ReactHardware2['default'].PropTypes;

var CHANGE_EVENT = 'topChange';
var CLOSE_EVENT = 'topClose';
var OPEN_EVENT = 'topOpen';

var EVENT_TYPE = (0, _ComponentUtils.collect)(_HardwareManager2['default'].customDirectEventTypes, CHANGE_EVENT, CLOSE_EVENT, OPEN_EVENT);

var SWITCH_REF = 'switch';

var viewConfig = {
  uiViewClassName: 'Switch',
  validAttributes: {
    pin: true,
    mode: true,

    onChange: true,
    onClose: true,
    onOpen: true } };

var Switch = (function (_React$Component) {
  function Switch() {
    _classCallCheck(this, Switch);

    if (_React$Component != null) {
      _React$Component.apply(this, arguments);
    }
  }

  _inherits(Switch, _React$Component);

  _createClass(Switch, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this = this;

      var nodeHandle = (0, _findNodeHandle2['default'])(this.refs[SWITCH_REF]);
      // set up the hardware polling
      _HardwareManager2['default'].read(nodeHandle, function (newValue) {
        if (newValue !== _this.value) {
          _this.value = newValue;

          var eventName = newValue === 0 ? CLOSE_EVENT : OPEN_EVENT;
          (0, _ComponentUtils.emitEvent)(_this, nodeHandle, eventName, newValue);
          (0, _ComponentUtils.emitEvent)(_this, nodeHandle, CHANGE_EVENT, newValue);
        }
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // TODO: maybe move this destroyer to the HardwareManager
      _HardwareManager2['default'].destroyRead((0, _findNodeHandle2['default'])(this.refs[SWITCH_REF]));
    }
  }, {
    key: 'render',
    value: function render() {
      var props = _extends({}, this.props);

      return _ReactHardware2['default'].createElement(Hardware, _extends({
        ref: SWITCH_REF,
        mode: _inputModes2['default'].INPUT
      }, props));
    }
  }]);

  return Switch;
})(_ReactHardware2['default'].Component);

var Hardware = (0, _createReactHardwareComponentClass2['default'])(viewConfig);

Switch.propTypes = _extends({}, _defaultPropTypes2['default'], {

  onChange: PropTypes.func,
  onClose: PropTypes.func,
  onOpen: PropTypes.func });

exports['default'] = Switch;
module.exports = exports['default'];